package io.educative.utils

import java.nio.CharBuffer
import java.util.Random
import java.util.concurrent.ThreadLocalRandom

import org.apache.commons.lang3.RandomStringUtils
import org.apache.commons.lang3.RandomStringUtils._

object Utilities {

  private final val specialChars = """" !"#$%&'()*+,-./:;<=>?@[\]^_`{|}~""""
  private final val alphabetsOnly = ('A' to 'Z').toBuffer ++ ('a' to 'z') mkString
  private final val alphabetsAndNumbers = ('A' to 'Z').toBuffer ++ ('a' to 'z') ++ ('0' to '9') mkString

  def randomNumber(start: Long, end: Long) = ThreadLocalRandom.current().nextLong(start, end + 1)

  def randomNumber(length: Int) = RandomStringUtils.randomNumeric(length)

  def randomMobileNumber = randomNumber(6, 9) + randomNumeric(9)

  def randomString(length: Int = 10, useAlphabetsOnly: Boolean = true, useNumber: Boolean = true, useSpecialChars: Boolean = false) = {
    if (useAlphabetsOnly && !useNumber) {
      random(length, alphabetsOnly)
    } else if (useNumber) {
      random(length, alphabetsAndNumbers)
    } else if (useAlphabetsOnly && useSpecialChars) {
      random(length, alphabetsOnly + specialChars)
    } else if (useNumber && useSpecialChars) {
      random(length, alphabetsAndNumbers + specialChars)
    }
  }

}
